class SimpleDeviceEntity {
  List<SimpleDevice> devices;

  SimpleDeviceEntity({this.devices});

  SimpleDeviceEntity.fromJson(Map<String, dynamic> json) {
    if (json['devices'] != null) {
      devices = new List<SimpleDevice>();
      (json['devices'] as List).forEach((v) {
        devices.add(new SimpleDevice.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.devices != null) {
      data['devices'] = this.devices.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class SimpleDevice {
  String category;
  String deviceId;
  String deviceName;
  String platform;

  SimpleDevice({this.category, this.deviceId, this.deviceName, this.platform});

  SimpleDevice.fromJson(Map<String, dynamic> json) {
    category = json['category'];
    deviceId = json['deviceId'];
    deviceName = json['deviceName'];
    platform = json['platform'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['category'] = this.category;
    data['deviceId'] = this.deviceId;
    data['deviceName'] = this.deviceName;
    data['platform'] = this.platform;
    return data;
  }
}

class UserDemo{
  final String name;
  final String email;

  UserDemo(this.name, this.email);
}
