import 'dart:io';
import '../response_bean.dart';
import 'base_controller.dart';
import 'package:jaguar/jaguar.dart';

final String api_devices_list = '/api/device/list';

class DeviceController extends BaseController {
  getDeviceList(Context ctx) async {
    ProcessResult result;
    try {
      result = Process.runSync('mgpcli', ['devices']);
      print("flutter device command result : ${result.stdout}");
      return Response(ResponseBean("${result.stdout}"));
    } on Exception catch (e) {
      print("flutter device command exception : ${e.toString()}");
      return Response(ResponseBean("${e.toString()}"));
    }
  }

  @override
  route(String path, Context context) async {
    if (match(path, api_devices_list)) {
      return getDeviceList(context);
    } else {
      return Response(ResponseBean("api path error."));
    }
  }
}
