# workflow

- [使用说明](#使用说明)
- [开发贡献](#开发贡献)
- [LICENSE](#license)

---

Flutter开发平台，通过workflow实现另一种flutter模块的创建，开发，编译，打包，上传流程；

![](doc/images/workflow-preview.png)

## 使用说明

### workflow安装

确保您安装并正确配置了flutter环境

```
export PATH=/*flutter directory*/flutter/bin:$PATH
```

同时建议配置`dart sdk`的环境变量，方便`pub`的使用

```
export PATH=/*flutter directory*/flutter/bin/cache/dart-sdk/bin:$PATH
```

通过pub或者flutter pub安装mpcli

```shell
pub global activate mgpcli
```

### workflow使用

通过mpcli命令工具可以创建一个flutter项目，并启动worklow进行编译。

1.创建flutter模块工程

```shell
# 创建模板工程
mgpcli create
```

2.启动workflow

```shell
# 进入新创建的工程目录内
cd your-project
# 启动workflow
mgpcli start
```

3.进入workflow

**现在已经为您打开了一个浏览器窗口**，请移步至窗口进行：[编译、Attach](http://127.0.0.1:8080)

## 贡献
源码贡献，请参考[CONTRIBUTING](CONTRIBUTING.md)

## LICENSE

[BSD 3-Clause "New" or "Revised" License](LICENSE)