# CLI device命令改动点

| 时间         | 说明        | 修改人  |
| ---------- | --------- | --------  |
|  2019.12.18     | CLI device命令改造点       | 李义新     |
|            |           |           |

## 背景
* workflow的设备管理需要展示连接的设备列表，CLI工程集成了flutter_tools源码，自带的`flutter devices`命令可以打印设备列表，故workflow调用CLI的命令来实现功能。

* flutter_tools代码量太大，剥离device命令成本很高，还要维护双份device代码、重复造轮子，不如直接统一调cli命令。

## 为什么要改造？

`flutter devices`原语的结果输出到控制台，格式不固定，无法解析设备相关的数据。因此，只需要约定某种json格式来输出即可，其他不需要改动。


* 改造前
```
  3 connected devices:

  SM G9500   • 98895a37564c595950 • android-arm64  • Android 9 (API 28)
  Chrome     • chrome             • web-javascript • Google Chrome 79.0.3945.79
  Web Server • web-server         • web-javascript • Flutter Tools
```
* 改造后
```
__device_start__{"devices":[{"category":"mobile","deviceId":"98895a37564c595950","deviceName":"SM
G9500","platform":"android"},{"category":"web","deviceId":"chrome","deviceName":"Chrome","platform":
"web"},{"category":"web","deviceId":"web-server","deviceName":"Web
Server","platform":"web"}]}__device_end__
```

这样，就可以解析`__device_start__` 、`__device_end__`之间json string.

### 改造后的优势

 * 随着系统flutter sdk的升级，自带命令不好去控制，统一走cli命令方便控制。

 * 可以按需自由发挥（比如基本信息页面，调用了sdk命令，将来有需求可以切成cli命令）。

### 如何使用？

* step1 下载CLI
  ```
  git clone git@igit.58corp.com:flutter-lab/magpie_cli.git
  ```
* step2 安装CLI（添加MagpieCLI到全局变量）
    ```
    pub global activate --source path <脚手架保存的文件夹全路径>
    ```

* step3 配置环境变量

    ```
    export PATH=$PATH:"$HOME/.pub-cache/bin"
    ```

* step4 运行`pub global list`，看到`MagpieCLI 0.0.0 at path "/Users/ethan/anjuke/magpie_cli"`即可。


* 参考：http://igit.58corp.com/flutter-lab/magpie_cli/blob/master/README.md




### change log

http://igit.58corp.com/flutter-lab/magpie_cli/merge_requests/4/diffs


