import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class ContentPanel extends StatelessWidget {
  final String title;
  final WidgetBuilder builder;
  final bool hideBar;
  final bool darkTheme;

  ContentPanel(
      {this.title,
      @required this.builder,
      this.hideBar = false,
      this.darkTheme = true})
      : assert(builder != null);

  @override
  Widget build(BuildContext context) {
    var inner = hideBar
        ? builder(context)
        : Column(children: <Widget>[
            Container(
              height: 60,
              width: double.infinity,
              color: Color.fromARGB(0xFF, 0x22, 0x22, 0x22),
              child: Align(
                alignment: Alignment.center,
                child: Text(title,
                    style: TextStyle(
                      color: Colors.white,
                      fontSize: 20,
                    )),
              ),
            ),
            builder(context),
          ]);
    return Expanded(
      child: darkTheme
          ? Container(
              color: const Color.fromARGB(0xFF, 0x11, 0x11, 0x11),
              child: DefaultTextStyle(
                style: TextStyle(color: Colors.white),
                child: inner,
              ),
            )
          : inner,
    );
  }
}
