import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

/// Add hover effect to text of [ListTile]
class HoverTile extends StatefulWidget {
  final String text;
  final TextStyle style;
  final GestureTapCallback onTap;
  final Color color;
  final Color hoverColor;

  HoverTile(this.text,
      {this.style,
      this.onTap,
      this.color = Colors.black,
      this.hoverColor = Colors.white});

  @override
  State<StatefulWidget> createState() {
    return _State();
  }
}

class _State extends State<HoverTile> {
  var _hover = false;

  @override
  Widget build(BuildContext context) {
    var color = _hover ? widget.hoverColor : widget.color;
    var style = widget.style?.copyWith(color: color) ?? TextStyle(color: color);
    return MouseRegion(
      onHover: (_) {
        if (_hover) {
          return;
        }
        setState(() {
          _hover = true;
        });
      },
      onExit: (_) {
        if (!_hover) {
          return;
        }
        setState(() {
          _hover = false;
        });
      },
      child: ListTile(
        title: Text(widget.text, style: style),
        onTap: () => widget.onTap(),
      ),
    );
  }
}