import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:workflow/component/hover_tile.dart';

// 按需扩展
class Sidebar extends StatelessWidget {
  final TapCallback _onTap;
  final List<String> _menus;

  const Sidebar({
    Key key,
    @required List<String> menus,
    @required TapCallback onTap,
  })  : assert(onTap != null),
        assert(menus != null && menus.length > 0),
        _menus = menus,
        _onTap = onTap,
        super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      width: 300,
      child: ListView(
        padding: EdgeInsets.zero,
        children: <Widget>[
          DrawerHeader(
            child: const Center(
              child: Text(
                'Workflow 1.0',
                style: TextStyle(
                  color: Colors.white,
                  fontWeight: FontWeight.w900,
                  fontSize: 30,
                ),
              ),
            ),
            decoration: BoxDecoration(
              color: Theme.of(context).primaryColor,
            ),
          ),
          // ignore: sdk_version_ui_as_code
          ...ListTile.divideTiles(
            context: context,
            tiles: List.generate(
              _menus.length,
              (i) => HoverTile(_menus[i], onTap: () => _onTap(i)),
            ),
          ).toList(),
        ],
      ),
    );
  }
}

typedef TapCallback = void Function(int index);
