import 'dart:convert';

import 'package:json_annotation/json_annotation.dart';

part 'simple_device.g.dart';

const deviceStart = "__device_start__";
const deviceEnd = "__device_end__";

@JsonSerializable()
class SimpleDevice extends Object {
  @JsonKey(name: 'category')
  String category;

  @JsonKey(name: 'deviceId')
  String deviceId;

  @JsonKey(name: 'deviceName')
  String deviceName;

  @JsonKey(name: 'platform')
  String platform;

  SimpleDevice(
    this.category,
    this.deviceId,
    this.deviceName,
    this.platform,
  );

  factory SimpleDevice.fromJson(Map<String, dynamic> srcJson) =>
      _$SimpleDeviceFromJson(srcJson);

  Map<String, dynamic> toJson() => _$SimpleDeviceToJson(this);

  static List<SimpleDevice> parseDevices(String origin) {
    final start = origin.indexOf(deviceStart);
    final end = origin.indexOf(deviceEnd);
    final finalJson = origin.substring(start + deviceStart.length, end);
    Map map = jsonDecode(finalJson);
    var array = map["devices"];
    if (array is Iterable) {
      var r = array.map<SimpleDevice>((item) {
        return SimpleDevice.fromJson(item);
      });
      return r.toList();
    }
    return [];
  }
}
